#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec-vm
Version:	4.1.5
Release:	1%{dist}
Summary:	The Qubes qrexec files (qube side)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:	pam-devel
BuildRequires:	pandoc
BuildRequires:	qubes-libvchan-devel
BuildRequires:	qubes-core-qrexec-devel
BuildRequires:	lsb-core-noarch

Requires:   python%{python3_pkgversion}
Requires:   qubes-core-qrexec = %{version}-%{release}

Provides:   qubes-core-agent-qrexec = 4.1.0-1
Obsoletes:  qubes-core-agent-qrexec < 4.1.0-1

Source0: qubes-core-qrexec-%{version}.tar.gz

%description
The Qubes qrexec files for installation on a qube.

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
export BACKEND_VMM=xen
make all-vm
#make -C doc PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} man

%install
make install-vm \
    DESTDIR=$RPM_BUILD_ROOT \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    SYSCONFDIR=%{_sysconfdir}

#make -C doc DESTDIR=$RPM_BUILD_ROOT \
#    PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} \
#    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%post
%systemd_post qubes-qrexec-agent.service

%preun
%systemd_preun qubes-qrexec-agent.service

%posttrans
# when upgrading from R4.0, %%postun of qubes-core-agent-qrexec will revert
# %%post of this package. Redo the action in %%posttrans
%systemd_post qubes-qrexec-agent.service
# and then start it back
if systemctl is-enabled qubes-qrexec-agent.service >/dev/null 2>&1; then
    systemctl start qubes-qrexec-agent.service
fi

%files
%defattr(-,root,root,-)
%config(noreplace) /etc/pam.d/qrexec
%dir /etc/qubes/rpc-config
/etc/qubes/rpc-config/README

%{_bindir}/qrexec-client-vm
%{_bindir}/qrexec-fork-server

%{_mandir}/man1/qrexec-client-vm.1*

/usr/lib/qubes/qrexec-agent
/usr/lib/qubes/qrexec-client-vm
/usr/lib/qubes/qrexec_client_vm
/lib/systemd/system/qubes-qrexec-agent.service

%changelog
* Thu Mar 26 2020 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec

* Thu Mar 26 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f760688
- version 4.1.5

* Wed Mar 25 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - dcc4ae9
- Isolate *-base, *-dom0 and *-vm make targets

* Wed Mar 25 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5d01785
- daemon: fix makefile

* Wed Mar 25 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a23648b
- version 4.1.4

* Fri Mar 20 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - bd07c52
- Fix race condition in process_io

* Fri Mar 20 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 5dc2e4c
- Add an error message in case of early break

* Fri Mar 20 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 5938b66
- Handle POLLERR for stdin as well as POLLHUP

* Fri Mar 20 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 5312443
- process_io: use poll, detect socket close

* Fri Mar 20 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - efb794c
- Fix qrexec-fork-server handling of MSG_JUST_EXEC

* Thu Mar 19 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 857e753
- Update log messages

* Tue Mar 17 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - c469fb7
- Include program name in logs

* Tue Mar 17 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 65a60f7
- Fix "executed user pid" message

* Tue Mar 17 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 44bcc76
- Convert error messages to logging macros

* Tue Mar 17 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 9f1bfce
- Add logging macros

* Sun Mar 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b1db5ac
- Adjust dependencies to avoid breaking non-executable services

* Sun Mar 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2fed52e
- Ensure matching libqrexec-utils package

* Sun Mar 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a97d482
- Test closing stdout early also through qrexec service

* Sun Mar 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ffafd01
- Fix not closed file descriptors in qubes-rpc-multiplexer

* Sat Mar 14 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a0b2122
- policy daemon: fix double ++ in logs

* Sat Mar 14 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bc5078d
- gitignore: ignore 'build' dir

* Sat Mar 14 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 87c589b
- Add '[Install]' section to qubes-qrexec-policy-daemon.service

* Sat Mar 14 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b68bde2
- libqrexec: fix cleanup on qubes_connect error

* Sat Mar 14 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4c51f26
- qrexec-client{,-vm}: do not fail if cannot sent just final EOF

* Sat Mar 14 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d4c589b
- Use different error messages for different error paths

* Tue Mar 10 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 96c279f
- Test stdio socket for client-vm as well

* Tue Mar 10 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 335a24b
- Handle SIGPIPE in qrexec-client-vm

* Tue Mar 10 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 2397e1e
- Fix test_exit_before_closing_streams

* Tue Mar 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 676f960
- policy: improve PolicyCache.cleanup()

* Tue Mar 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2cf9aad
- policy: don't fail if policy directory doesn't exist

* Sun Mar 08 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 489f2e8
- Remove debug print

* Sun Mar 08 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 3a8cbd6
- Add a test for replace_chars

* Sun Mar 08 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 7bbfeaf
- Split handle_new_process_common

* Sun Mar 08 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 1613675
- qrexec-client-vm: pass local process PID to process_io

* Sun Mar 08 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - dfc55e6
- Always return remote exit status

* Fri Mar 06 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 216dba9
- Fix timeout in wait_for_vchan_or_argfd

* Fri Mar 06 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 405ae7d
- Move all closing code to process_io.c; don't exit early

* Fri Mar 06 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 4166b19
- Add a test in which we wait for a granchild to close streams

* Fri Mar 06 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 908a156
- Fix reading from a dead process (ECONNRESET on read)

* Fri Mar 06 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 95fa4bb
- agent: fix error path on failed service exec

* Fri Mar 06 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 80002db
- qrexec-client: use common code for process_io

* Fri Mar 06 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 0802df7
- Factor out process_child_io

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 3c65541
- Fix replace_chars usage

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 925c5cd
- Factor out send_exit_code()

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - b4a6029
- qrexec-client: use the common handle_input

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - c7b7317
- Factor out handle_input from qrexec-agent-data.c

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 33ec781
- qrexec-client: use handle_remote_data instead of handle_vchan_data

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 6aadf77
- Factor out handle_remote_data to libqrexec

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 26376b3
- Extract do_replace_chars()

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 255debd
- Add tests that trigger WRITE_STDIN_BUFFERED

* Thu Mar 05 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - ec18e37
- Add tests that cover writing into closed stdin

